//
// Created by huli on 2021/12/20.
//

#include "string_convert.h"


String_convert::String_convert()
{

}

String_convert::~String_convert()
{

}

#ifdef _WIN32
#include <windows.h>

std::string String_convert::gbk_to_utf8(const char *src_str)
{
	int len = MultiByteToWideChar(CP_ACP, 0, src_str, -1, NULL, 0);
	wchar_t* wstr = new wchar_t[len + 1];
	memset(wstr, 0, len + 1);
	MultiByteToWideChar(CP_ACP, 0, src_str, -1, wstr, len);
	len = WideCharToMultiByte(CP_UTF8, 0, wstr, -1, NULL, 0, NULL, NULL);
	char* str = new char[len + 1];
	memset(str, 0, len + 1);
	WideCharToMultiByte(CP_UTF8, 0, wstr, -1, str, len, NULL, NULL);
	std::string strTemp = str;
	if (wstr) delete[] wstr;
	if (str) delete[] str;
	return strTemp;
}

std::string String_convert::utf8_to_gbk(const char *src_str)
{
	int len = MultiByteToWideChar(CP_UTF8, 0, src_str, -1, NULL, 0);
	wchar_t* wszGBK = new wchar_t[len + 1];
	memset(wszGBK, 0, len * 2 + 2);
	MultiByteToWideChar(CP_UTF8, 0, src_str, -1, wszGBK, len);
	len = WideCharToMultiByte(CP_ACP, 0, wszGBK, -1, NULL, 0, NULL, NULL);
	char* szGBK = new char[len + 1];
	memset(szGBK, 0, len + 1);
	WideCharToMultiByte(CP_ACP, 0, wszGBK, -1, szGBK, len, NULL, NULL);
	std::string strTemp(szGBK);
	if (wszGBK) delete[] wszGBK;
	if (szGBK) delete[] szGBK;
	return strTemp;
}
#else
#include <iconv.h>

int String_convert::gbk_to_utf8(char *str_str, size_t src_len, char *dst_str, size_t dst_len)
{
	iconv_t cd;
	char **pin = &str_str;
	char **pout = &dst_str;

	cd = iconv_open("utf8", "gbk");
	if (cd == 0)
		return -1;
	memset(dst_str, 0, dst_len);
	if (iconv(cd, pin, &src_len, pout, &dst_len) == -1)
		return -1;
	iconv_close(cd);
	**pout = '\0';

	return 0;
}

int String_convert::utf8_to_gbk(char *src_str, size_t src_len, char *dst_str, size_t dst_len)
{
	iconv_t cd;
	char **pin = &src_str;
	char **pout = &dst_str;

	cd = iconv_open("gbk", "utf8");
	if (cd == 0)
		return -1;
	memset(dst_str, 0, dst_len);
	if (iconv(cd, pin, &src_len, pout, &dst_len) == -1)
		return -1;
	iconv_close(cd);
	**pout = '\0';

	return 0;
}

std::string String_convert::gbk_to_utf8(std::string src_str)
{
	char* dst_str = new char[src_str.length() + 5];
	memset(dst_str, 0, src_str.length() + 5);

	std::string strTemp;
	if ( gbk_to_utf8( (char*)src_str.c_str(), src_str.length(), dst_str, src_str.length() + 5) == 0 )
	{
		strTemp = dst_str;
	}
	if ( dst_str )
	{
		delete(dst_str);
	}
	return strTemp;
}
std::string String_convert::utf8_to_gbk(std::string src_str)
{
	char* dst_str = new char[src_str.length() + 5];
	memset(dst_str, 0, src_str.length() + 5);

	std::string strTemp;
	if ( utf8_to_gbk( (char*)src_str.c_str(), src_str.length(), dst_str, src_str.length() + 5) == 0 )
	{
		strTemp = dst_str;
	}
	if ( dst_str )
	{
		delete(dst_str);
	}
	return strTemp;
}

#endif